--- ../geany/src/callbacks.c	2008-03-02 07:19:49.000000000 -0600
+++ ./src/callbacks.c	2008-03-03 17:37:34.000000000 -0600
@@ -918,37 +918,36 @@
 	gint idx = document_get_cur_idx();
 	ScintillaObject *sci = doc_list[idx].sci;
 	gchar *text;
-	gboolean keep_sel = TRUE;
+	gint curr_pos = -1;
 
 	if (! DOC_IDX_VALID(idx))
 		return;
 
 	if (! sci_can_copy(sci))
 	{
+		curr_pos = sci_get_current_position(sci);
 		keybindings_cmd(GEANY_KEYS_EDIT_SELECTWORD);
-		keep_sel = FALSE;
 	}
 
 	if (sci_can_copy(sci))
 	{
-		gchar *result;
+		gint result;
 		gint text_len = sci_get_selected_text_length(sci);
 
 		text = g_malloc(text_len + 1);
 		sci_get_selected_text(sci, text);
 
 		if (utils_str_has_upper(text))
-			result = g_utf8_strdown(text, -1);
+			result = SCI_LOWERCASE;
 		else
-			result = g_utf8_strup(text, -1);
+			result = SCI_UPPERCASE;
 
-		sci_replace_sel(sci, result);
+		sci_cmd(sci, result);
 
-		g_free(result);
 		g_free(text);
 
-		if (keep_sel)
-			sci_set_selection_start(sci, sci_get_current_position(sci) - text_len + 1);
+		if (curr_pos>=0)
+			sci_set_current_position(sci, curr_pos, FALSE);
 	}
 }
 